import string
import re
import urlparse
import os
from ftplib import FTP
import time

version = "0.0.1"

update_interval  = 300 # second(s)
first_update = 1 # second(s)

media = []
icon_path = "/usr/share/pixmaps/mdk-check-update/"
icon_uptodate = icon_path + "uptodate.png"
icon_obsolete = icon_path + "obsolete.png"

re_begin_medium = re.compile("^(\S*)\s*(\S*)\s*{$")
re_hdlist = re.compile("^\s*hdlist:\s*(\S*)$")
re_with_hdlist = re.compile("^\s*with_hdlist:\s*(\S*)$")
re_synthesis = re.compile("^\s*synthesis$")
re_end_medium = re.compile("}$")

def read_config():
	global media
	media = []
	f = open("/etc/urpmi/urpmi.cfg","r")
	for line in f.readlines():
		begin_medium = re_begin_medium.match(line)
		hdlist = re_hdlist.match(line)
		with_hdlist = re_with_hdlist.match(line)
		synthesis = re_synthesis.match(line)
		end_medium = re_end_medium.match(line)
		if begin_medium:
			medium_info = {}
			medium_info['name'] = begin_medium.group(1)
			medium_info['url'] = begin_medium.group(2)
			medium_info['type'] = urlparse.urlparse(medium_info['url'])[0]
		elif hdlist:
			medium_info['hdlist'] = hdlist.group(1)
		elif with_hdlist:
			medium_info['with_hdlist'] = with_hdlist.group(1)
		elif synthesis:
			medium_info['synthesis'] = 1
		elif end_medium:
			media.append(medium_info)
	f.close()

ftp_reply = ""
def ftp_reply_keep_last_cb(x):
	global ftp_reply
	ftp_reply = x

def check_media():
	for medium in media:
		# get name and date of local medium hdlist
		local_name = "/var/lib/urpmi/"
		if 'synthesis' in medium:
			local_name += "synthesis."
		local_name += medium['hdlist']
		local_date =  os.path.getmtime(local_name)

		# get name of remote hdlist
		if 'with_hdlist' in medium:
			hdlist = medium['with_hdlist']
		else:
			hdlist = medium['hdlist']

		# get name and date of remote hdlist and adjust local date if needed
		remote_name = ""
		remote_date = 0
		if medium['type'] == 'ftp':
			remote_name = urlparse.urljoin(medium['url'] + "/", hdlist)
			(scheme,netloc,path,parameters,query,fragment) = urlparse.urlparse(remote_name)
			ftp = FTP(netloc)
			ftp.login()
			ftp.retrlines('LIST ' + path, ftp_reply_keep_last_cb)
			ftp.close()

			# keep the date
			(month, day, other) = ftp_reply.split()[5:8]
			if ':' in other:
				# other is the date
				date_format = "%b %d %H:%M %Y"
				remote_date = time.mktime(time.strptime(string.join([month, day, other, str(time.gmtime().tm_year)]), date_format))
			else:
				# other is the year
				date_format = "%b %d %Y"
				remote_date = time.mktime(time.strptime(string.join([month, day, other]), date_format))
				
			# very very ugly hack not to care about seconds or other things that don't matter
			local_date = time.mktime(time.strptime(time.strftime(date_format, time.localtime(local_date)), date_format))
		elif medium['type'] == 'rsync':
			continue # os.popen() doesn't work with gnome-python :/
			# drop rsync://
			remote_name = medium['url'].replace("rsync://", "") + "/" +  hdlist
			# use rsync to find the date of remote hdlist
			f = os.popen("/usr/bin/rsync " + remote_name)
			label.set_text("Rsync 3")
			label.set_text(f.readlines(1))
			l = f.readlines()
			label.set_text("Rsync 4")
			f.close()
			label.set_text("Rsync 5")
			(date, hour) = l[0].split()[2:4]
			label.set_text("Rsync 6")
			remote_date = time.mktime(time.strptime(string.join([date, hour]), "%Y/%m/%d %H:%M:%S"))
			label.set_text("Fin Rsync")

		if (remote_date > local_date):
			# a new hdlist is available for this medium
			medium['update_available'] = 1
